// sorgente: malloc.c

// illustra il corretto utilizzo dalla funzione malloc() e
// della free()

// inclusione del file di intestazione della libreria standard
// che contiene definizioni di macro, costanti e dichiarazioni
// di funzioni e tipi funzionali alle varie operazioni di I/O
#include <stdio.h>

// inclusione del file di intestazione della libreria
// standard che contiene definizioni di macro,
// costanti e dichiarazioni di funzioni di interesse generale
#include <stdlib.h>

// visualizza il contenuto di un buffer di interi
void VisBuffInt(int *ptr, size_t nro_val)
  {
  // definisce la variabile necessaria a muoversi sul buffer
  int curs;
  
  // attraversa il buffer visualizzandone il contenuto
  for (curs = 0; curs <= nro_val-1; curs++)
    printf("\nElemento %d: %d", curs, ptr[curs]);
  };
  
// alloca, visualizza e successivamente rilascia, un buffer
// per un numero di valori interi specificato a run-time
int main()
  {
  // definisce le variabili per il numero dei valori interi
  // e per il riferimento al buffer
  size_t nro_val;
  int *ptr;
  
  // inizializza la variabile per il numero di valori nel
  // buffer
  printf("\nQuanti valori? ");
  scanf("%u", &nro_val);
  
  // alloca memoria per il buffer
  ptr = (int *)malloc(nro_val * sizeof(int));
  
  // se l'allocazione  fallita termina
  if (ptr == NULL)
    {
    printf("\nAllocazione fallita");
    return(0);
    };
  
  // se l'allocazione  avvenuta con successo visualizza
  // il contenuto del buffer e rilascia la memoria per
  // questo allocata
  printf("\nAllocazione avvenuta con successo\n");
  printf("\nContenuto del buffer: ");
  VisBuffInt(ptr, nro_val);
    
  // rilascia la memoria allocata per il buffer
  free(ptr);
  
  return(1);
  }
